net.minecraft.world.gen

## Class MapGenCaves

- java.lang.Object
- - net.minecraft.world.gen.MapGenBase
  - - net.minecraft.world.gen.MapGenCaves

-     public class MapGenCaves
      extends MapGenBase

- - ### Field Summary

    - ### Fields inherited from class net.minecraft.world.gen.MapGenBase

      `rand, range, worldObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MapGenCaves()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `digBlock(Block[] data, int index, int x, int y, int z, int chunkX, int chunkZ, boolean foundTop)` Digs out the current block, default implementation removes stone, filler, and top block Sets the block to lava if y is less then 10, and air other wise.
    `protected void` | `func_151538_a(World p_151538_1_, int p_151538_2_, int p_151538_3_, int p_151538_4_, int p_151538_5_, Block[] p_151538_6_)`
    `protected void` | `func_151541_a(long p_151541_1_, int p_151541_3_, int p_151541_4_, Block[] p_151541_5_, double p_151541_6_, double p_151541_8_, double p_151541_10_, float p_151541_12_, float p_151541_13_, float p_151541_14_, int p_151541_15_, int p_151541_16_, double p_151541_17_)`
    `protected void` | `func_151542_a(long p_151542_1_, int p_151542_3_, int p_151542_4_, Block[] p_151542_5_, double p_151542_6_, double p_151542_8_, double p_151542_10_)`
    `protected boolean` | `isOceanBlock(Block[] data, int index, int x, int y, int z, int chunkX, int chunkZ)`

    - ### Methods inherited from class net.minecraft.world.gen.MapGenBase

      `func_151539_a`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MapGenCaves

          public MapGenCaves()

  - ### Method Detail

    - #### func_151542_a

          protected void func_151542_a(long p_151542_1_,
                           int p_151542_3_,
                           int p_151542_4_,
                           Block[] p_151542_5_,
                           double p_151542_6_,
                           double p_151542_8_,
                           double p_151542_10_)

    - #### func_151541_a

          protected void func_151541_a(long p_151541_1_,
                           int p_151541_3_,
                           int p_151541_4_,
                           Block[] p_151541_5_,
                           double p_151541_6_,
                           double p_151541_8_,
                           double p_151541_10_,
                           float p_151541_12_,
                           float p_151541_13_,
                           float p_151541_14_,
                           int p_151541_15_,
                           int p_151541_16_,
                           double p_151541_17_)

    - #### func_151538_a

          protected void func_151538_a(World p_151538_1_,
                           int p_151538_2_,
                           int p_151538_3_,
                           int p_151538_4_,
                           int p_151538_5_,
                           Block[] p_151538_6_)

      Overrides:
        `func_151538_a` in class `MapGenBase`

    - #### isOceanBlock

          protected boolean isOceanBlock(Block[] data,
                             int index,
                             int x,
                             int y,
                             int z,
                             int chunkX,
                             int chunkZ)

    - #### digBlock

          protected void digBlock(Block[] data,
                      int index,
                      int x,
                      int y,
                      int z,
                      int chunkX,
                      int chunkZ,
                      boolean foundTop)

      Digs out the current block, default implementation removes stone, filler, and top block Sets the block to lava if y is less then 10, and air other wise. If setting to air, it also checks to see if we've broken the surface and if so tries to make the floor the biome's top block
      Parameters:
        `data` - Block data array
        `index` - Pre-calculated index into block data
        `x` - local X position
        `y` - local Y position
        `z` - local Z position
        `chunkX` - Chunk X position
        `chunkZ` - Chunk Y position
        `foundTop` - True if we've encountered the biome's top block. Ideally if we've broken the surface.